module chaosdc(x, sd, dither, m, clock, reset, y, overflow);
// berekent Y(z) = X(z)/(8(z-1,09375))
// calculates Y(z) = X(z)/(8(z-1.09375))
parameter limitlength = 10;
parameter wordlength = 35;
parameter c = 34'd1974121616;
// parameter [wordlength-2:0] c = 1974121616; 
parameter [limitlength-1:0] max = 567;
input signed [wordlength-1:0] x;
input sd;
input signed [5:0] dither;
input [1:0] m;
// methode: alleen methode 01 gebruikt chaos
// method: only method 01 uses chaos
input clock;
input reset;
output signed [wordlength-1:0] y;
output overflow;
reg signed [6:0] ditherplusoffset;
reg signed [wordlength+5:0] som1;
reg signed [wordlength+6:0] som2;
reg signed [wordlength-1:0] y_int;
reg [limitlength+1:0] som2abs;
reg overflow_int;
integer Piet;
always @ (*)
begin
	ditherplusoffset = $signed({dither[5], dither[5:0]}) + $signed(7'b0010000);
	if (sd)
		som1 = $signed({x[wordlength-1], x[wordlength-1], x[wordlength-1], x[wordlength-1], x[wordlength-1:0], 2'b00}) - $signed({2'b0, c, 5'b0});
	else
		som1 = $signed({x[wordlength-1], x[wordlength-1], x[wordlength-1], x[wordlength-1], x[wordlength-1:0], 2'b00}) + $signed({2'b0, c, 5'b0});
	som2 = som1 + ditherplusoffset + y_int + (y_int<<<1) + (y_int<<<5);
	if (som2[wordlength+6])
		som2abs[limitlength+1:0] = ~som2[wordlength+5:wordlength+4-limitlength];
	else
		som2abs[limitlength+1:0] = som2[wordlength+5:wordlength+4-limitlength];
end
always @ (posedge clock)
begin
	if (reset | (m != 2'b01)) 
	begin
		y_int <= 0;
		overflow_int <= 0;
	end
	else if (som2abs > max)
	begin
		overflow_int <= 1;  //ingeklokte overflow, eigenlijk niet consequent
		if (som2[wordlength+6]) //negatief (negative)
		begin
			y_int[wordlength-1] <= 1;
			y_int[wordlength-2:wordlength-limitlength-1] <= ~max;
			for (Piet=0; Piet<wordlength-limitlength-1; Piet=Piet+1) y_int[Piet] <= 1;
		end
		else
		begin
			y_int[wordlength-1] <= 0;
			y_int[wordlength-2:wordlength-limitlength-1] <= max;
			for (Piet=0; Piet<wordlength-limitlength-1; Piet=Piet+1) y_int[Piet] <= 0;
		end
	end
	else
	begin
		overflow_int <= 0;
		y_int[wordlength-1:0] <= {som2[wordlength+6], som2[wordlength+3:5]};
	end
end
assign y = $signed(y_int);
assign overflow = overflow_int;
endmodule
