module dithergen(clock, reset, seed, outl, outr);
input clock, reset;
input [63:0] seed;
output signed [32:0] outl;
output signed [32:0] outr;
wire [63:0] a;
wire [31:0] aodd;
wire [31:0] aeven;
reg [32:0] b;
reg signed [32:0] c;
xorshiftplus xsp1(clock, reset, seed[63:0], a);
assign aodd = {a[63], a[61], a[59], a[57], a[55], a[53], a[51], a[49], a[47], a[45], a[43], a[41], a[39], a[37], a[35], a[33], a[31], a[29], a[27], a[25], a[23], a[21], a[19], a[17], a[15], a[13], a[11], a[9], a[7], a[5], a[3], a[1]};
assign aeven = {a[62], a[60], a[58], a[56], a[54], a[52], a[50], a[48], a[46], a[44], a[42], a[40], a[38], a[36], a[34], a[32], a[30], a[28], a[26], a[24], a[22], a[20], a[18], a[16], a[14], a[12], a[10], a[8], a[6], a[4], a[2], a[0]};
always @ (posedge clock)
begin
	b <= aodd + aeven;
	c <= aodd - aeven;
end
assign outl[31:0] = b[31:0];
assign outl[32] = ~b[32];
assign outr[32:0] = c[32:0];
endmodule
