module dopdetector(reset, bck, lrck, data, dsddet);
// Detector voor het DSD-over-PCM-markeringspatroon.
// Detector for the DSD-over-PCM marker pattern.
parameter [7:0] patroon = 8'b10100000;
input reset, bck, lrck, data;
output dsddet;
reg [8:0] teller;
reg [7:0] bitteller;
reg omenom, lrck_oud;
always @ (posedge bck)
begin
	if (reset)
	begin
		bitteller <= 8'b0;
		teller <= 9'b0;
		lrck_oud <= 1'b0;
		omenom <= 1'b0;
	end
	else
	begin
		lrck_oud <= lrck;
		if (lrck_oud ^ lrck)
			bitteller <= 8'b0;
		else
			bitteller <= bitteller + 1;
		if (bitteller < 8)
		begin
			if (data == patroon[bitteller] ^ omenom)
				if (teller[8] == 1'b0)
					teller <= teller + 1;
				else
					teller <= 9'b100000000;
			else
				teller <= 9'b000000000;
		end
		if ((teller > 6) & (~lrck) & lrck_oud)
			omenom <= ~omenom;
	end
end
assign dsddet = teller[8];
endmodule
