module interpol(sdclock, firclock, bck4392, lrck4392, reset, data4392, filter_sel, ditherl1, ditherr1, ditherl2, ditherr2, doutl, doutr, fclip);
	parameter wordlengthfirint3out = 58;
	parameter wordlengthfirint5in = 32;
	parameter wordlengthfirint5out = 65;
	parameter wordlengthout = 35;
	input sdclock, reset, data4392;
	input [1:0] filter_sel;
	// filter_sel[0] -> correctie voor analoog filter, correction for analogue filter
	// filter_sel[1] -> 50 us/15 us deemfase, 50 us/15 us deemphasis
	input signed [32:0] ditherl1; // overbodige bits laten we hier wel doodlopen
	input signed [32:0] ditherl2; // overbodige bits laten we hier wel doodlopen
	input signed [32:0] ditherr1; // overbodige bits laten we hier wel doodlopen
	input signed [32:0] ditherr2; // overbodige bits laten we hier wel doodlopen
	// Unnecessary dither bits are left unconnected at this hierarchical level.
	output signed [wordlengthout-1:0] doutl;
	output signed [wordlengthout-1:0] doutr;
	output firclock, bck4392, lrck4392, fclip;
	reg fclip3l, fclip3r, fclip5l, fclip5r;
	reg longreset;
	reg resetack;
	reg [52:0] sipo;
	reg signed [23:0] links;
	reg signed [23:0] rechts;
	reg signed [32:0] ditherl1synch;
	reg signed [32:0] ditherr1synch;
	reg signed [32:0] ditherl2synch;
	reg signed [32:0] ditherr2synch;
	wire signed [wordlengthfirint3out-1:0] links3;
	wire signed [wordlengthfirint3out-1:0] rechts3;
	wire signed [wordlengthfirint5out-1:0] links15;
	wire signed [wordlengthfirint5out-1:0] rechts15;
	wire signed [wordlengthfirint5out-1:0] links15d;
	wire signed [wordlengthfirint5out-1:0] rechts15d;
	reg signed [wordlengthfirint3out-1:0] l3d;
	reg signed [wordlengthfirint3out-1:0] r3d;
	reg signed [wordlengthfirint5in-1:0] din2l;
	reg signed [wordlengthfirint5in-1:0] din2r;
	reg aap, noot, mies;
	wire wim;
	reg nd1, nd2l, nd2r, resets1, resetsynchsd, startfiforead, rd_en;
	reg [3:0] tel9;
	reg [2:0] tel5;
	reg [5:0] tel54;
	reg [5:0] klokschuif;
	wire rdy1l, rdy1r, rdy2l, rdy2r, prog_emptyr, prog_emptyl, fulll, fullr, emptyl, emptyr; 
	wire rfd1l, rfd1r, rfd2l, rfd2r;
	reg signed [wordlengthout-1:0] fiforin;
	reg signed [wordlengthout-1:0] fifolin;
	reg rdy2ld, rdy2rd;
	wire CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, firclock180, LOCKED, PSDONE, CLKFB;
	wire [7:0] STATUS;
	//klokken maken, making clocks
	DCM_SP #(.CLKDV_DIVIDE(3.0), //Afgedeelde uitgang is gerelateerd aan fin en is dus onbruikbaar.
		.CLKFX_DIVIDE(1),
		.CLKFX_MULTIPLY(8),
		.CLKIN_DIVIDE_BY_2("FALSE"),
		.CLKIN_PERIOD(37.037),
		.CLKOUT_PHASE_SHIFT("FIXED"),
		.CLK_FEEDBACK("1X"), //????
		.DESKEW_ADJUST("SYSTEM_SYNCHRONOUS"), //????
		.DFS_FREQUENCY_MODE("LOW"),
		.DLL_FREQUENCY_MODE("LOW"),
		.DSS_MODE("NONE"),
		.DUTY_CYCLE_CORRECTION("TRUE"),
		.FACTORY_JF(16'hc080),
		.PHASE_SHIFT(0), // 0/256 times input clock period
		.STARTUP_WAIT("FALSE"))
		DCM_SP_inst (CLK0, CLK180, CLK270, CLK2X, CLK2X180, CLK90, CLKDV, firclock, firclock180, LOCKED, PSDONE, STATUS, CLK0, sdclock, 1'b0, 1'b0, 1'b0, 1'b0, reset);
		// CLKFB op CLK0 aansluiten is eigenlijk niet eens nodig als je alleen CLKFX maar gebruikt.
		// Connecting CLKFB to CLK0 is actually not even needed when you only use CLKFX.

		// Gebruik sdreset, hij mag pas losgelaten worden
		// als de 27 MHz-klok ingeregeld is!
		// Use the sdreset and only release it after the 27 MHz
		// clock is properly settled!

		reg locked_long, locked_synch1, locked_synch2;
		always @ (posedge firclock or negedge LOCKED)
			if (~LOCKED)
			begin
				locked_long <= 1'b0;
				locked_synch1 <= 1'b0;
				locked_synch2 <= 1'b0;
			end
			else
			begin
				locked_synch1 <= LOCKED;
				locked_synch2 <= locked_synch1;
				locked_long <= locked_synch2;
			end

	always @ (posedge firclock or posedge reset)
	begin
		if (reset)
			longreset <= 1'b1;
		else
		begin
			if (~ locked_long)
				longreset <= 1'b1;
			else
				longreset <= longreset & (~resetack);
		end
	end
	// Je moet er rekening mee houden dat resetack onbepaald is
	// zolang er geen firclock is! Vandaar het gedoe met locked_long.
	// Keep in mind that resetack is undefined as long as there is
	// no firclock! Hence the use of locked_long.
	
	always @ (posedge firclock) klokschuif[5:0] <= {klokschuif[4:0], sdclock};
	
	assign wim = (klokschuif[0] & (~klokschuif[1]))|(klokschuif[4] & (~klokschuif[5])); 
	always @ (posedge firclock)
	begin
		if (wim)
		begin
			if (longreset)
			begin
				tel5 <= 3'b001;
				tel54 <= 6'b000101;
				resetack <= 1'b1;
				// Verlengde reset nodig, want firclock 
				// begint pas nadat gewone reset is afgelopen!
				// Longer reset needed, because firclock
				// starts when the normal reset is gone!
			end
			else
			begin
				resetack <= 1'b0;
				if (tel5 == 3'b101)
				begin
					tel5 <= 3'b001;
					if (tel54 == 6'b111010)
						tel54 <= 6'b000101;
					else
						tel54 <= tel54+1;
				end
				else
					tel5 <= tel5+1;
			end
		end
		else resetack <= 1'b0;
	end
	assign bck4392 = tel5[2];
	assign lrck4392 = tel54[5];
	always @ (posedge bck4392)
		sipo[52:0] <= {sipo[51:0],data4392};
	always @ (negedge lrck4392)
	begin
		rechts <= sipo[25:2];
		links <= sipo[52:29];
	end
	always @ (posedge bck4392 or posedge longreset)
	begin
		if (longreset)
			aap <= 1'b0;
		else
			aap <= lrck4392;
	end
	always @ (posedge firclock)
	begin
		noot <= aap;
		mies <= noot;
	end
	always @ *
		nd1 = (~noot) & mies;
	firint3 firl (
	.sclr(longreset), // input sclr
	.clk(firclock), // input clk
	.nd(nd1), // input nd
	.filter_sel(filter_sel), // input [1 : 0] filter_sel
	.rfd(rfd1l), // output rfd
	.rdy(rdy1l), // output rdy
	.din(links), // input [23 : 0] din
	.dout(links3)); // output [57 : 0] dout
	firint3 firr (
	.sclr(longreset), // input sclr
	.clk(firclock), // input clk
	.nd(nd1), // input nd
	.filter_sel(filter_sel), // input [1 : 0] filter_sel
	.rfd(rfd1r), // output rfd
	.rdy(rdy1r), // output rdy
	.din(rechts), // input [23 : 0] din
	.dout(rechts3)); // output [57 : 0] dout
	always @ (posedge firclock)
	begin
		ditherl1synch <= ditherl1;
		ditherr1synch <= ditherr1;
	end

// Pijpleidingerij, pipe lining:
	reg rdy1lp, rdy1rp;
	always @ (posedge firclock)
	begin
		r3d <= rechts3 + $signed(ditherr1synch[32:32-wordlengthfirint3out+wordlengthfirint5in]);
		l3d <= links3 + $signed(ditherl1synch[32:32-wordlengthfirint3out+wordlengthfirint5in]);
		rdy1lp <= rdy1l;
		rdy1rp <= rdy1r;
	end

	always @ (posedge firclock)
	begin
		case (l3d[wordlengthfirint3out-1:wordlengthfirint3out-3])
			3'b111:
			begin
				fclip3l <= 0;
				din2l[wordlengthfirint5in-1:0] <= l3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthfirint5in-2];
			end
			3'b000:
			begin
				fclip3l <= 0;
				din2l[wordlengthfirint5in-1:0] <= l3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthfirint5in-2];
			end
			default:
			begin
				fclip3l <= 1;
				// din2l <= din2l;
			end
		endcase
		nd2l <= rdy1lp;
		case (r3d[wordlengthfirint3out-1:wordlengthfirint3out-3])
			3'b111:
			begin
				fclip3r <= 0;
				din2r[wordlengthfirint5in-1:0] <= r3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthfirint5in-2];
			end
			3'b000:
			begin
				fclip3r <= 0;
				din2r[wordlengthfirint5in-1:0] <= r3d[wordlengthfirint3out-3:wordlengthfirint3out-wordlengthfirint5in-2];
			end
			default:
			begin
				fclip3r <= 1;
				// din2r <= din2r; // Vorige monster herhalen
				// bij oversturing, repeat previous sample
				// when clipping.
			end
		endcase
		nd2r <= rdy1rp;
	end
	firint5 fir2l (
	.sclr(longreset), // input sclr
	.clk(firclock), // input clk
	.nd(nd2l), // input nd
	.rfd(rfd2l), // output rfd
	.rdy(rdy2l), // output rdy
	.din(din2l), // input [31 : 0] din
	.dout(links15)); // output [64 : 0] dout
	firint5 fir2r (
	.sclr(longreset), // input sclr
	.clk(firclock), // input clk
	.nd(nd2r), // input nd
	.rfd(rfd2r), // output rfd
	.rdy(rdy2r), // output rdy
	.din(din2r), // input [31 : 0] din
	.dout(rechts15)); // output [64 : 0] dout
// Dither gepijplijnd.
// Dither pipelined to solve potential timing problem.
	reg signed [64:0] links15p;
	reg signed [64:0] rechts15p;
	reg rdy2lp, rdy2rp;
	always @ (posedge firclock)
	begin
		ditherl2synch <= ditherl2;
		ditherr2synch <= ditherr2;
		links15p <= links15;
		rechts15p <= rechts15;
		rdy2lp <= rdy2l;
		rdy2rp <= rdy2r;
	end
	assign links15d = links15p + $signed(ditherl2synch[32:32-wordlengthfirint5out+wordlengthout]);
	assign rechts15d = rechts15p + $signed(ditherr2synch[32:32-wordlengthfirint5out+wordlengthout]);
	always @ (posedge firclock)
	begin
		case (links15d[wordlengthfirint5out-1:wordlengthfirint5out-2])
			2'b11:
			begin
				fclip5l <= 0;
				fifolin <= links15d[wordlengthfirint5out-2:wordlengthfirint5out-wordlengthout-1];
			end
			2'b00:
			begin
				fclip5l <= 0;
				fifolin <= links15d[wordlengthfirint5out-2:wordlengthfirint5out-wordlengthout-1];
			end
			default:
			begin
				fclip5l <= 1;
				// fifolin <= fifolin; // Bij oversturing
				// laatste monster herhalen, repeat last
				// sample when clipping.
			end
		endcase
		rdy2ld <= rdy2lp;
		case (rechts15d[wordlengthfirint5out-1:wordlengthfirint5out-2])
			2'b11:
			begin
				fclip5r <= 0;
				fiforin <= rechts15d[wordlengthfirint5out-2:wordlengthfirint5out-wordlengthout-1];
			end
			2'b00:
			begin
				fclip5r <= 0;
				fiforin <= rechts15d[wordlengthfirint5out-2:wordlengthfirint5out-wordlengthout-1];
			end
			default:
			begin
				fclip5r <= 1;
				// fiforin <= fiforin;
			end
		endcase
		rdy2rd <= rdy2rp;
	end
	fifo64 fifol (
  	.rst(longreset), // input rst
  	.wr_clk(firclock), // input wr_clk
  	.rd_clk(sdclock), // input rd_clk
  	.din(fifolin), // input [34 : 0] din
  	.wr_en(rdy2ld), // input wr_en
  	.rd_en(rd_en), // input rd_en
  	.dout(doutl), // output [34 : 0] dout
  	.full(fulll), // output full
  	.empty(emptyl), // output empty
  	.prog_empty(prog_emptyl) // output prog_empty
	);	
	fifo64 fifor (
  	.rst(longreset), // input rst
  	.wr_clk(firclock), // input wr_clk
  	.rd_clk(sdclock), // input rd_clk
  	.din(fiforin), // input [34 : 0] din
  	.wr_en(rdy2rd), // input wr_en
  	.rd_en(rd_en), // input rd_en
  	.dout(doutr), // output [34 : 0] dout
  	.full(fullr), // output full
  	.empty(emptyr), // output empty
  	.prog_empty(prog_emptyr) // output prog_empty
	);
	always @ (posedge sdclock)
	begin
		if (resetsynchsd)
			tel9 <= 4'b0000;
		else
		begin
			if (tel9[3])
				tel9 <= 4'b0000;
			else
				tel9 <= tel9 + 4'b0001;
		end
		resets1 <= reset;
		resetsynchsd <= resets1;
		startfiforead <= (~resetsynchsd) & (startfiforead|(~(prog_emptyl|prog_emptyr)));
	end
	always @ *
		rd_en = tel9[3] & startfiforead;
	assign fclip = fclip3l || fclip3r || fclip5l || fclip5r;
endmodule
