module pwm(x, m, rot, clock, reset, y);
	input signed [3:0] x;
	input [1:0] m; // 00: x eenwaardig (single value), 01: tweewaardig (two-valued), 10: vijfwaardig (five-valued), 11: negenwaardig (nine-valued)
	input [2:0] rot; // toevalsgetal, 0...7 met elk kans 1/8. random number, 0...7 each with probability 1/8
	input clock, reset;
	output y;
//	output [2:0] count;
	reg [3:0] hulp;
	reg [3:0] hulp2;
	reg [2:0] hulp3;
	reg [2:0] rotation;
	reg y_int;
	reg [2:0] count_int;
	always @ (posedge clock)
	begin
		if (reset)
		begin
			count_int <= 0;
			hulp <= 0;
			rotation <= 0;
		end
		else
		begin
			if (count_int == 0)
			begin
				case(m)
					2'b00:
					begin
						count_int <= 1; // 01010101... voor stilte, 01010101... for silence
						hulp <= 1;
						rotation <= 0;
					end
					2'b01:
					begin
						count_int <= 0;
						hulp[3:1] <= 3'b000;
						hulp[0] <= ~x[0];
						rotation <= 0;
					end
					2'b10:
					begin
						count_int <= 3;
						hulp[3:0] <= $signed(x[3:0]) + 4'sb0010;
						rotation[2] <= 1'b0;
						rotation[1:0] <= rot[1:0];
					end
					2'b11:
					begin
						count_int <= 7;
						hulp[3:0] <= $signed(x[3:0]) + 4'sb0100;
						rotation <= rot;
					end
				endcase
			end
			else
				count_int <= count_int - 3'b001;
		end
	end
	always @ *
	begin
		hulp2 = count_int + rotation;
		case (m)
			2'b10:
			begin
				hulp3[1:0] = hulp2[1:0];
				hulp3[2] = 1'b0;
			end
			default: hulp3[2:0] = hulp2[2:0];
		endcase
		if (hulp3 < hulp)
			y_int = 1;
		else
			y_int = 0;
	end
	assign y = y_int;
//	assign count = count_int;
endmodule
