module subb (x, sd, c, y, overflow);
// berekent y = x - sd*c. sd wordt opgevat als +/-1,
// dus 1 wordt +1 en 0 wordt -1.
// calculates y = x - sd*c. sd is interpreted as +/-1,
// thus 1 becomes +1 and 0 becomes -1.
parameter wordlength = 35;
// lengte van x en y, c is een bit korter want c heeft geen teken.
// length of x and y, c is one bit shorter because c has no sign.
parameter wordlengthmin1 = wordlength - 1;
input signed [wordlength-1:0] x;
input sd;
input [wordlength-2:0] c;
output signed [wordlength-1:0] y;
output overflow;
reg overflow_int;
reg signed [wordlength:0] verschil;
reg signed [wordlength-1:0] y_int;
always @ (*)
begin
	if (sd)
		verschil = x-$signed(c);
	else
		verschil = x+$signed(c);
	case (verschil[wordlength:wordlength-1])
		2'b01:
		begin
			y_int = {1'b0, {wordlengthmin1{1'b1}}};
			overflow_int = 1;
		end
		2'b10:
		begin
			y_int = {1'b1, {wordlengthmin1{1'b0}}};
			overflow_int = 1;
		end
		default:
		begin
			y_int = verschil[wordlength-1:0];
			overflow_int = 0;
		end
	endcase
end
assign y = y_int;
assign overflow = overflow_int;
endmodule
